﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace Hardanger.Features.ServerFuzzer.ServerFuzzerEngine
{
    public static class ServerFuzzerEngineFactory
    {
        public static ObservableCollection<string> GetAllFuzzers()
        {
            return new ObservableCollection<string>(
                AppDomain.CurrentDomain.GetAssemblies().ToList()
                .SelectMany(s => s.GetTypes())
                .Where(p => typeof(IServerFuzzerEngine).IsAssignableFrom(p) && !p.IsInterface)
                .Select(c => c.Name).ToList());
        }
        public static IServerFuzzerEngine Create(string name)
        {
            var engine = AppDomain.CurrentDomain.GetAssemblies().ToList()
               .SelectMany(s => s.GetTypes())
               .Where(t => typeof(IServerFuzzerEngine).IsAssignableFrom(t) && t.Name == name).SingleOrDefault(); //Throw an error if more than one found
            return (IServerFuzzerEngine)System.Activator.CreateInstance(Type.GetType(engine.FullName));
        }
    }
}
