﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Hardanger.ViewModel;
using Hardanger.Model;
using System.Collections.ObjectModel;

namespace Hardanger.View
{
    /// <summary>
    /// Interaction logic for HardangerMain.xaml
    /// </summary>
    public partial class HardangerMain : UserControl
    {
        public HardangerMain()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(HardangerMain_Loaded);

        }

        void HardangerMain_Loaded(object sender, RoutedEventArgs e)
        {    
			hdTabs.Items.Add(GetServerFuzzerTab());
			hdTabs.Items.Add(GetResultsTab());
			hdTabs.Items.Add(GetAboutTab());
        }

		private static TabItem GetServerFuzzerTab()
		{
			TabItem about = new TabItem();
			about.Header = "Server Fuzzer";
			about.Content = new ServerFuzzerView();
			return about;
		}

		private static TabItem GetResultsTab()
		{
			TabItem about = new TabItem();
			about.Header = "Results";
			about.Content = new ResultsView();
			return about;
		}      

		private static TabItem GetAboutTab()
		{
			TabItem about = new TabItem();
			about.Header = "About";
			about.Content = new About();
			return about;
		}      
    }
}
